/**
@author Cesar Vasquez Ibaceta
@version 3.0 01-06-04
*/

import javax.swing.*;
import java.lang.String.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Toolkit.*;
import java.awt.geom.*;
import java.awt.Graphics2D.*;


/**
Crea un panel de botones.
*/
public class ButtonPanel extends JPanel
{
   private final int b = 5;  //setea el borde
   /**
   El Constructor de esta clase, crea un Panel, seteando el Laoyout Manager en
   GridLayout y creando un grilla de (X, Y) para poder agregar otros objetos.
   @param x numero de Filas de la grilla.
   @param y numero de Columnas de la grilla.
   @param tipo Tipo de panel, se utiliza para poner un titulo en el borde del 
   panel
   */
   public ButtonPanel(int x, int y, String tipo)
   {
      setBorder(BorderFactory.createCompoundBorder(
      BorderFactory.createTitledBorder(tipo),              //nombre del panel
      BorderFactory.createEmptyBorder(b, b, b, b)    //seteo de bordes
      ));
      setLayout(new GridLayout(x, y, b, b));      //numero de filas y columnas.
   }

   /**
   Agrega un boton al panel de botones y un Listener al boton.
   @param label nombre del boton que se desea crear
   @param listener nombre del Listener al que se desea asociar dicho boton.
   */
   public void agregarBoton(String label, ActionListener listener)
   {
      //se crea un boton llamado <I>label</I>
      JButton boton = new JButton(label);  
      //se agrega el ActionListener recibido, al boton
      boton.addActionListener(listener);   
      add(boton);    //se agrega el boton al panel
   }
}
