/**
@author Cesar Vasquez Ibaceta
@version 3.0 01-06-04
*/

import java.io.*;
import java.util.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import java.lang.String.*;

/**
Se crea un objeto para crear un FileChooser y poder cargar 
posteriormente un archivo con extension .EDA
*/
public class CargarFiguras
{ 
   private ArrayList figuras;
   private String archivo;
   
   /**
   Un objeto vacio, que sirve para manipular la carga de elementos
   en formato .eda
   */
   public CargarFiguras()
   {
   }

   /**
   Metodo encargado de realizar el cargado de figuras previamente
   creadas con el editor, en formato .eda
   @return retorna un <B>ArrayList</B> con las figuras cargadas desde dicsco.
   */
   public ArrayList load()
   {
      JFileChooser fileChooser = new JFileChooser(); 
      figuras = new ArrayList();
      //filtro para las extensiones
      ExtensionsFileFilter filter = new ExtensionsFileFilter(); 
      filter.addExtension(".eda");  //extensiones aceptadas.
      filter.setDescription("Archivos .eda"); //descripcion de las eextensiones
      //se elimina la opcion "todos los archivos" del FileChooser
      fileChooser.setAcceptAllFileFilterUsed(false);  
      fileChooser.setFileFilter(filter);
      int status = fileChooser.showOpenDialog(null); 
      if (status == JFileChooser.APPROVE_OPTION) 
      {
         //se crea un Archivo elegido con el FileChooser
         File selectedFile = fileChooser.getSelectedFile();
         try 
         {
            ObjectInputStream in = new ObjectInputStream(
               new FileInputStream(selectedFile.getParent() + "\\"
                  + selectedFile.getName()));
            //el archivo guardado es un ArrayList
            figuras = (ArrayList)in.readObject(); 
            in.close();
         } 
         catch (Exception e) 
         {
            //en el caso que el archivo no exista, sea no valido, etc..
            System.out.print("Al parecer, el archivo " 
               + selectedFile.getName() 
               + ", no es compatible con este editor o no existe.\n");
            System.out.print("Error: " + e);
            System.exit(1);
         }
      }
      //se devuelve el ArrayList cargado desde el disco.
      return figuras;
   }
}
