/**
@author Cesar Vasquez Ibaceta
@version 3.0 01-06-04
*/

import javax.swing.*;
import java.lang.String.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;

/**
Crea un panel con RadioButtons.
*/
public class ColorPanel extends JPanel
{
   private static String defaultColor = "n e g r o";
   private static int b; 
   private ButtonGroup group;
   
   /**
   El Constructor de esta clase, crea un Panel, seteando el Laoyout Manager en
   GridLayout y creando un grilla de (X, Y) para poder agregar otros objetos.
   @param x numero de Filas de la grilla.
   @param y numero de Columnas de la grilla.
   @param name se utiliza para poner un titulo en el borde del panel
   */
   public ColorPanel(int x, int y, String name)
   {
      setBorder(BorderFactory.createCompoundBorder(
         BorderFactory.createTitledBorder(name),         //nombre del panel
         BorderFactory.createEmptyBorder(b, b, b, b)  //seteo de bordes
      ));
      setLayout(new GridLayout(x, y, b, b));
      group = new ButtonGroup();    //se agrupan los radio buttons para que 
                        //solo pueda estar presionado un boton a la vez        
   }
   
   /**
   Metodo encargado de crear un RadioButton y agregarlo a este panel.
   @param label nombre del RadioButton.
   @param listener ActionListener que se asociara al boton.
   */
   public void addRadioButton(String label, ActionListener listener)
   {
      //solo estar seleccionado en un comienzo, el 
      //RadioButton que concuerde con el color por defecto.
      boolean selected = defaultColor.equals(label);    
      //se crea un radio button
      JRadioButton rbutton = new JRadioButton(label, selected);    
      //se agrega un listener al RadioButton
      rbutton.addActionListener(listener);   
      group.add(rbutton);     //se agrupa con los otros
      add(rbutton);  //se agrega al panel 
   }
}

