/**
@author Cesar Vasquez Ibaceta
@version 3.0 01-06-04
*/

import java.io.*;
import java.util.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import java.lang.String.*;

/**
Crea un objeto con un ArrayList que luego sera guardado en disco 
mediante el metodo Save(). 
*/
public class GuardarFiguras
{
   private ArrayList figuras;
   private String archivo;
   
   /**
   Guarda el ArrayList que posteriormente sera guardado en disco
   @param f ArrayList que sera guardado en disco.
   */
   public GuardarFiguras(ArrayList f)
   {
      figuras = f;
   }
   
   /**
   Metodo encargado de guardar en disco el ArrayList <B>Figuras</B>
   @return retorna un objeto File, en donde se escribira nuestro archivo
   con extension .fig
   */
   public File save()
   {
      int l, i;
      String nameFig;

      JFileChooser fileChooser = new JFileChooser();  //se crea un FileChooser
      //se crea un Filtro para las extensiones
      ExtensionsFileFilter filter = new ExtensionsFileFilter();   
      filter.addExtension(".eda");     //se agrega la extension .eda
      filter.setDescription("Archivos .eda");   //la descripcion de la extension
      //se elimina la opcion "todos los archivos" del FileChooser
      fileChooser.setAcceptAllFileFilterUsed(false);  
      fileChooser.setFileFilter(filter);  //se agrega el filtro al FileChosser
      int status = fileChooser.showSaveDialog(null); 
      if (status == JFileChooser.APPROVE_OPTION) 
      {  //se crea un Archivo elegido con el FileChooser
         File selectedFile = fileChooser.getSelectedFile();
         try 
         {
            //nombre y ruta del archivo a guardar.
            archivo = new String(selectedFile.getParent() + "\\"
                  + selectedFile.getName());    
            if (!archivo.endsWith(".eda")) 
               archivo = new String(archivo + ".eda");
            //se crea un ObjectOutputStream para escribir en el archivo
            ObjectOutputStream out = new ObjectOutputStream(
                  new FileOutputStream(archivo));  
            out.writeObject(figuras);  //se guarda el ArrayList
            out.close();   //se cierra el archivo
            
            return setExt(selectedFile);
         } 
         catch (Exception e) 
         {  //se capturan las excepciones arrojadas por errores en 
            //el manejo del archivo.
            System.out.print("Error: " + e);
            System.exit(1);
         } 
      }
      return null;   
   }

   /**
   Cambia la extension del archivo especificado en el FileChooser
   por una extension .fig
   @param selectedFile archivo especificado por el FileChooser
   @return un archivo con extension .fig en la misma ruta del archivo .eda
   */
   public File setExt(File selectedFile)
   {
      final int L_EXT = 4;
      String nameFig;
      //formatea la extension del archivo .fig
      String name = new String(selectedFile.getParent() + "\\" 
         + selectedFile.getName());
      if (name.endsWith(".eda"))
         name = name.substring(0, name.length() - L_EXT);
      nameFig = new String(name + ".fig");   
      File archivoFig = new File(nameFig);
      //devuelve un archivo con extension .fig para extortar
      return archivoFig;
   }


}

